<template>
  <div class="app-container">
    <el-card>
      <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="88px">
        <el-form-item label="畜种类型" prop="animalType">
          <el-select v-model="queryParams.animalType">
            <el-option v-for="(item, i) in animalList" :key="i" :value="item.typeValue" :label="item.typeName"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="产品名称" prop="productName">
          <el-input
            v-model="queryParams.productName"
            placeholder="请输入产品名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>

      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button
            type="primary"
            plain
            icon="el-icon-plus"
            size="mini"
            @click="handleAdd"
            v-hasPermi="['app:productCategory:add']"
          >新增</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="danger"
            plain
            icon="el-icon-delete"
            size="mini"
            :disabled="multiple"
            @click="handleDelete"
            v-hasPermi="['app:productCategory:remove']"
          >删除</el-button>
        </el-col>
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>
    </el-card>
    <br>
    <el-card>
      <el-table border stripe  v-loading="loading" :data="productCategoryList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55"  />
        <el-table-column label="畜种类型">
          <template slot-scope="scope">
            <span>{{animalName(scope.row.animalType)}}</span>
          </template>
        </el-table-column>
        <el-table-column label="产品名称"  prop="productName" />
        <el-table-column label="单位"  prop="unit" />
        <el-table-column label="约当重量(kg)" prop="eqWeight"></el-table-column>
        <el-table-column label="是否在售"  prop="onSaleFlag" >
          <template slot-scope="scope">
            <el-tag type="primary" v-if="scope.row.onSaleFlag === 1">在售</el-tag>
            <el-tag type="danger" v-else-if="scope.row.onSaleFlag === 0">不在售</el-tag>
          </template>
        </el-table-column>
        <el-table-column label="操作" width="180"  class-name="small-padding fixed-width">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleView(scope.row)"
            >查看</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              @click="handleUpdate(scope.row)"
              v-hasPermi="['app:productCategory:edit']"
            >修改</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDelete(scope.row)"
              v-hasPermi="['app:productCategory:remove']"
            >删除</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />

    </el-card>
    <!-- 添加或修改产品分类对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form"  label-position="left" :model="form" :rules="rules" :disabled="isView" label-width="80px">
        <el-form-item label="畜种类型" prop="animalType">
          <el-select v-model="form.animalType">
            <el-option v-for="(item, i) in animalList" :key="i" :value="item.typeValue" :label="item.typeName"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="产品名称" prop="productName">
          <el-input v-model="form.productName" :placeholder="isView ? '' :'请输入产品名称'" show-word-limit maxlength="10"/>
        </el-form-item>
        <el-form-item label="产品单位" prop="unit">
          <el-input v-model="form.unit" :placeholder="isView ? '' :'请输入产品单位'" show-word-limit maxlength="5" />
        </el-form-item>
        <el-form-item label="约当重量" prop="eqWeight">
          <el-input v-model="form.eqWeight" :placeholder="isView ? '' :'请输入约当重量'" >
            <template #append>kg</template>
          </el-input>
        </el-form-item>
        <el-form-item label="是否在售" prop="onSaleFlag">
          <el-radio-group v-model="form.onSaleFlag">
            <el-radio :label="0">不在售</el-radio>
            <el-radio :label="1">在售</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer" v-if="!isView">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listProductCategory, getProductCategory, delProductCategory, addProductCategory, updateProductCategory } from "@/api/app/productCategory";
import {mapState} from "vuex";

const validateNumber = (rule, value, callback) => {
  console.log(rule, value)
    if (value === '' || value === null || value === 0) {
      callback();
      return;
    }

    // 正则验证：大于等于0，最多2位小数，但不能是0.00
    const regex = /^(0(\.0?[1-9])?|0\.[0-9][1-9]|[1-9]\d*(\.\d{1,2})?)$/;

    if (!regex.test(value.toString())) {
      callback(new Error('请输入大于等于0的数字，最多2位小数'));
      return;
    }

    callback();
}
export default {
  name: "ProductCategory",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 产品分类表格数据
      productCategoryList: [],
      // 弹出层标题
      title: "",
      isView:false,
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        animalType: null,
        productName: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        animalType: [
          { required: true, message: "畜种类型不能为空", trigger: "change" },
        ],
        productName: [
          { required: true, message: "产品名称不能为空", trigger: "blur" },
          { min: 1, max: 10, message: "产品名称输入超出最大长度限制（10位）", trigger: "blur" },
        ],
        eqWeight: [
          { validator: validateNumber, trigger: 'blur' }
        ]
      }
    };
  },
  computed: {
    ...mapState({
      animalList: state => state.user.animalList
    }),
    animalName() {
      return (value) => {
        if (value === null) return '未知'
        const animal = this.animalList.find(item =>
          String(item.typeValue) === String(value)
        )
        return animal ? animal.typeName : '未知'
      }
    }
  },
  created() {
    // this.loading = false;
    this.getList();
  },
  methods: {
    /** 查询产品分类列表 */
    getList() {
      this.loading = true;
      listProductCategory(this.queryParams).then(response => {
        this.productCategoryList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        animalType: null,
        productName: null,
        unit: null,
        eqWeight: null,
        onSaleFlag: 1
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.isView = false;
      this.title = "添加产品";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getProductCategory(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.isView = false;
        this.title = "修改产品";
      });
    },
     /** 查看按钮操作 */
     handleView(row) {
      this.reset();
      const id = row.id || this.ids
      getProductCategory(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.isView = true;
        this.title = "查看产品";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateProductCategory(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addProductCategory(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除所选数据项？').then(function() {
        return delProductCategory(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('app/productCategory/export', {
        ...this.queryParams
      }, `productCategory_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
